/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "USBFS_msc_cust.h"
#include "general.h"
#include "USBFS_SCSI_operations.h"

extern void USBFS_HandleMassStorageInRequests(void);
void USBFS_HandleMassStorageOutRequests(void);

/* SRAM allocated for emulating the file system. */
uint8 emulatedMemory[USBFS_MSC_EM_IMAGE_SIZE];


int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
    USBFS_Start(0,USBFS_3V_OPERATION);
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    if(USBFS_GetConfiguration())
	{
		/* Re-enable the OUT EP */
		USBFS_EnableOutEP(2);
        
    }    
    InitMassStorage();
    USBFS_InitializeMSC();
    for(;;)
    {
        /* Place your application code here. */
        if(USBFS_GetConfiguration())
	    {
    		/* Check for the Configuration to Change, if so then re-enable the OUT EP */
    		if(USBFS_IsConfigurationChanged())
    		{
    			USBFS_EnableOutEP(2);
    		}
        }
        
        /* Check buffer status and handle mass storage events. Execute SCSI commands in the next level. */
		if(USBFS_GetEPState(MSC_EP_IN) == USBFS_IN_BUFFER_EMPTY)
		{
			USBFS_HandleMassStorageInRequests();
		}
		if(USBFS_GetEPState(MSC_EP_OUT) == USBFS_EVENT_PENDING)
		{
			USBFS_HandleMassStorageOutRequests(); 
		}
    				

    }
}

/* [] END OF FILE */
